% Script to help make a surface element
.grid_snap 0
.new_text
This script helps you construct a reflecting surface element.


Do you want to proceed?
.yes_no SKIP
.new_text
The first thing you must do is select a starting point. To do this,
click with the "Start" cursor somewhere in the Raytrace window.


Select your starting point on the basis of giving yourself enough
room to draw the element within the window. You can move the element
to the exact position that you want when it is finished.
.create_surface
.user_click
:CHOOSESTYPE
.new_text
Elements are made up of segments. You must decide what type of segment
you want to use. Click on:


A - for a straight line segment

B - for a circular arc segment

C - for a conic section segment

D - to undo the last segment

E - to finish the surface
.choose 5 LINE ARC CONIC UNDO CLOSE
:LINE
.lineseg
.new_text
When drawing line segments you simply click with the "End" cursor
at the point where you want the line segment to end.
.user_click
.goto CHOOSESTYPE
:ARC
.arcseg
.new_text
When drawing arc segments you have a choice of how to specify the arc.
Click on


A - to specify the end point and initial tangent direction

B - to specify a radius and end point

C - to specify a centre and end point
.choose 3 ARC1 ARC2 ARC3
:ARC1
.new_text
.chord_tan
Click with "End" cursor where you want the arc to end.
.user_click
.new_text
Click with the "Tangent" cursor at a point which will lie
on the tangent to the arc at the starting point.
.user_click
.goto CHOOSESTYPE
:ARC2
.radius_end
.new_text
You can either


A - Specify a numerical value or

B - Drag the cursor to set the radius
.choose 2 ENTERRAD DRAGRAD
:ENTERRAD
.new_text
Enter the desired radius.
.fast_click_rel userinput 0
.goto SETARCDIR
:DRAGRAD
.new_text
The radius of the arc will be set equal to the length of the rubberband
when you click the mouse button. Drag the "Radius" cursor until you
get the desired length.
.user_click
:SETARCDIR
.new_text
Do you want this arc to be drawn in


A - a clockwise direction or

B - a counter-clockwise direction?
.choose 2 CLKWISE ANTICLK
:CLKWISE
.clockwise_arc
.goto CHSEND
:ANTICLK
.anticlockwise_arc
:CHSEND
.new_text
Now click with the "End" cursor where you want the arc to end.
.user_click
.goto CHOOSESTYPE
:ARC3
.new_text
.centre_end
Click with the "Centre" cursor where you want the centre of the arc to be.
.user_click
.new_text
Do you want this arc to be drawn in


A - a clockwise direction or

B - a counter-clockwise direction?
.choose 2 CLKWISE2 ANTICLK2
:CLKWISE2
.clockwise_arc
.goto CHSEND2
:ANTICLK2
.anticlockwise_arc
:CHSEND2
.new_text
Now click with the "End" cursor where you want the arc to end.
.user_click
.goto CHOOSESTYPE
:CONIC
.conicseg
:CONIC2
.new_text
Choose the option you want for this conic.


A - Give me help on the options

B - Focus and end points fixed, vertex defines axis direction only.

C - Focus and vertex points fixed, end defines direction to end only.

D - Vertex fixed, focus defines axis dir'n, eccentricity specified.

E - Vertex and end points fixed, eccentricity specified.

F - Focus and end points fixed, eccentricity specified.
.choose 6 CONICHELP FE FV VEX VEEX FEEX
:CONICHELP
.new_text
When defining a conic segment you always specify 3 points in addition to
the starting point of the conic which is already fixed by what you have done
so far. These points are the "Focus", "Vertex" and "End" points. Depending
on which option you choose these points will be used in different ways
to define the conic. For some options you also need to specify an
eccentricity value.
.pause
.new_text
If you choose the first option (B) then the conic segment will be
constrained to have its focus and end points where you specified.
The vertex point will be used only to define the direction of the conic
axis. The final vertex position and eccentricity are determined
for you.
.pause
.new_text
If you choose the second option (C) then the conic segment will be
constrained to have its focus and vertex points where you specified.
The conic segment will end where it intersects a line drawn between the
focus point and the end point you specified. The eccentricity is
determined for you.
.pause
.new_text
If you choose the third option (D) then the conic segment will be
constrained to have its vertex where you specified. The focus point
is only used to define the axis direction. An eccentricity must be
specified. The conic will end where it crosses a line drawn between
the focus (when it is determined) and the end point specified.
.pause
.new_text
The fourth option (E) is probably the easiest to use. The conic segment
is constrained to pass through both the vertex and end points you specify.
You must specify the eccentricity. The focus point is determined for you
and does not depend upon where you click in response to the "Focus" cursor.
.pause
.new_text
The last option (F) is similar to the one just mentioned except the focus
point is fixed and the vertex will be determined to fit the focus, end and
eccentricity.
.pause     
.goto CONIC2
:FE
.conic_options focus_end_axis
.new_text
Click where you want the focus of the conic to be.
.user_click
.new_text
Click on a point which will lie on the axis of the conic, somewhere
near where you think the vertex should lie. The actual vertex
point will be determined by other parameters with this option.
.user_click
.new_text
Click where you want the conic to end.
.user_click
.goto CHOOSESTYPE
:FV
.conic_options focus_vertex_endangle
.new_text
Click where you want the focus of the conic to be.
.user_click
.new_text
Click where you want the conic vertex to be.
.user_click
.new_text
Click to specify the end direction of the conic. The conic will end
where it intersects a line drawn between the focus point and the end
point you specify.
.user_click  
.goto CHOOSESTYPE
:VEX
.input_limits -1.5 1.5
.default_input 1.0
.new_text
Enter the value you want for the eccentricity. This script limits
your input values to +/- 1.5. Beware of strange results if you
use eccentricity values greater than 1. For hyperbolic curves it
is often impossible to fit the specified constraints unless you plan
the position of points correctly.
.conic_options vertex_axis_eccent userinput
.new_text
Click on a point which will lie on the axis of the conic (somewhere near
where you think the focus should be). The actual focus position will be
determined from the other parameters with this option.
.user_click
.new_text
Click where you want the vertex of the conic to lie.
.user_click
.new_text
Click to specify the end direction of the conic. The conic will end
where it intersects a line drawn between the focus point and the end
point you specify.
.user_click  
.goto CHOOSESTYPE
:VEEX
.input_limits -1.5 1.5
.default_input 1.0
.new_text
Enter the value you want for the eccentricity. This script limits
your input values to +/- 1.5.  Beware of strange results if you
use eccentricity values greater than 1. For hyperbolic curves it
is often impossible to fit the specified constraints unless you plan
the position of points correctly.
.conic_options vertex_end_eccent userinput
.new_text
Click somewhere near where you think the focus should be. Anywhere will
do really as this point is not used with this option.
.user_click
.new_text
Click where you want the conic vertex to be.
.user_click
.new_text
Click where you want the conic to end.
.user_click
.goto CHOOSESTYPE
:FEEX
.input_limits -1.5 1.5
.default_input 1.0
.new_text
Enter the value you want for the eccentricity. This script limits
your input values to +/- 1.5.  Beware of strange results if you
use eccentricity values greater than 1. For hyperbolic curves it
is often impossible to fit the specified constraints unless you plan
the position of points correctly.
.conic_options focus_end_eccent userinput
.new_text
Click where you want the conic focus to be.
.user_click
.new_text
Click somewhere near where you think the vertex should be. Anywhere will
do really as this point is not used with this option.
.user_click
.new_text
Click where you want the conic to end.
.user_click
.goto CHOOSESTYPE
:UNDO
.undo
.goto CHOOSESTYPE
:CLOSE
.end_element
:SKIP
.return
